const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const traits = sequelize.define(
    'traits',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

code: {
        type: DataTypes.TEXT,
      
      

      },

data_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"decimal",


"int",


"boolean",


"enum",


"string"

        ],

      },

unit: {
        type: DataTypes.ENUM,
      
      

        values: [

"none",


"cm",


"mm",


"m",


"g",


"kg",


"brix",


"percent",


"count",


"celsius",


"fahrenheit",


"ph"

        ],

      },

aggregation: {
        type: DataTypes.ENUM,
      
      

        values: [

"none",


"avg",


"min",


"max",


"sum",


"last"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  traits.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
















    db.traits.hasMany(db.observations, {
      as: 'observations_trait',
      foreignKey: {
          name: 'traitId',
      },
      constraints: false,
    });







//end loop



    db.traits.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.traits.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.traits.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.traits.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return traits;
};


